/*
 * BufferSelectorPlugin.java
 * Copyright (c) 1999, 2000 Chris Laird, Andre Kaplan
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


import java.util.Vector;

import org.gjt.sp.jedit.EBMessage;
import org.gjt.sp.jedit.EBPlugin;
import org.gjt.sp.jedit.GUIUtilities;
import org.gjt.sp.jedit.jEdit;
import org.gjt.sp.jedit.View;
import org.gjt.sp.jedit.gui.OptionsDialog;
import org.gjt.sp.jedit.msg.PropertiesChanged;
import org.gjt.sp.jedit.msg.ViewUpdate;


/**
 * The <CODE>Plugin</CODE> implementation for the BufferSelector.
 * @author Andre Kaplan
 * @author Chris Laird
 * $Id: BufferSelectorPlugin.java,v 1.6 2000/12/31 16:19:43 akaplan Exp $
**/
public class BufferSelectorPlugin
    extends EBPlugin
{
    public void start() {}


    public void stop() {}


    public void createMenuItems(Vector menuItems) {
        menuItems.addElement(
            GUIUtilities.loadMenuItem("toggle-buffer-selector")
        );
    }


    public void createOptionPanes(OptionsDialog dialog) {
        dialog.addOptionPane(new BufferSelectorOptionPane());
    }


    public void handleMessage(EBMessage message) {
        if (message instanceof ViewUpdate) {
            ViewUpdate vu = (ViewUpdate)message;
            View view = vu.getView();
            if (vu.getWhat() == ViewUpdate.CREATED) {
                if (jEdit.getBooleanProperty(
                        "buffer-selector.default-enabled", false)
                ) {
                    BufferSelector.addTo(view);
                }
            } else if (vu.getWhat() == ViewUpdate.CLOSED) {
                if (BufferSelector.isEnabledFor(view)) {
                    BufferSelector.removeFrom(view);
                }
            }
        } else if (message instanceof PropertiesChanged) {
            BufferSelector.propertiesChanged();
        }
    }
}
